const wx2my = require('../../wx2my');
const Behavior = require('../../Behavior');
// component/picNav/picNav.js
var app = getApp();

const wxService = require('../../utils/wxService');

const utils = require('../../utils/util');

const envInfo = require('../../config/index').envInfo;

Component({
  /**
   * 组件的属性列表
   */
  props: {
    picNav: []
  },

  didMount() {
    this.setData({
      baseImgUrl: app.globalData.imageUrl
    });
  },

  /**
   * 组件的初始数据
   */
  data: {
    baseImgUrl: ''
  },

  /**
   * 组件的方法列表
   */
  methods: {
    preview(e) {
      const {
        url,
        currentUrl
      } = e.currentTarget.dataset;
      wx2my.previewImage({
        current: `${app.globalData.imageUrl}/${currentUrl}`,
        // 当前显示图片的http链接
        urls: [`${app.globalData.imageUrl}/${url}`] // 需要预览的图片http链接列表

      });
    }

  }
});